#pragma once

#include <memory>
#include <string>

class Socket
{
    using SocketHandle = int;
public:

    Socket();

    ~Socket();

    static std::unique_ptr<Socket> Create();

    std::string getAddress() const;

    SocketHandle getHandle() const;

    unsigned getPort() const;

    std::string getMessage() const;

    void setPort(unsigned port);

    void setHandle(SocketHandle handle);

    void setMessage(const std::string& message);

    void setAddress(const std::string& address);

private:
    SocketHandle mHandle;
    unsigned mPort{0};
    std::string mMessage;
    std::string mAddress;
};

using SocketPtr = std::unique_ptr<Socket>;
